    All Packages  Class Hierarchy  This Package  Previous  Next  Index

# Class java.awt.Rectangle

    java.lang.Object
       |
       +----java.awt.Rectangle

public class Rectangle
extends Object
implements Shape, Serializable

A rectangle specifies an area in a coordinate space that is defined by the rectangle's top-left point (x, y) in the coordinate space, its width, and its height.

A rectangle's `width` and `height` are public fields. The constructors that allow you to create a rectangle, and the methods that allow you to modify one, do not prevent you from setting a negative value for width or height.

A rectangle whose width or height is negative is considered empty, and all methods defined by the `Rectangle` class behave accordingly. If the rectangle is empty, then the method `isEmpty` returns `true`. No point can be contained by or inside an empty rectangle, however the values of `width` and `height` are still valid. An empty rectangle still has a location in the coordinate space, and methods that change its size or location remain valid. The behavior of methods that operate on more than one rectangle is undefined if any of the participating rectangles has a negative `width` or `height`. These methods include `intersects`, `intersection`, and `union`.

##

height
  The height of the rectangle.
width
  The width of the rectangle.
x
  The x coordinate of the rectangle.
y
  The y coordinate of the rectangle.

##

Rectangle()
  Constructs a new rectangle whose top-left corner is at (0, 0) in the coordinate space, and whose width and height are zero.
Rectangle(Dimension)
  Constructs a new rectangle whose top left corner is (0, 0) and whose width and height are specified by the `dimension` argument.
Rectangle(int, int)
  Constructs a new rectangle whose top-left corner is at (0, 0) in the coordinate space, and whose width and height are specified by the arguments of the same name.
Rectangle(int, int, int, int)
  Constructs a new rectangle whose top-left corner is specified as (`x`, `y`) and whose width and height are specified by the arguments of the same name.
Rectangle(Point)
  Constructs a new rectangle whose top-left corner is the specified point, and whose width and height are zero.
Rectangle(Point, Dimension)
  Constructs a new rectangle whose top-left corner is specified by the `point` argument, and whose width and height are specified by the `dimension` argument.
Rectangle(Rectangle)
  Constructs a new rectangle, initialized to match the values of the specificed rectangle.

##

add(int, int)
  Adds a point, specified by the integer arguments `newx` and `newy`, to this rectangle.
add(Point)
  Adds the point `pt` to this rectangle.
add(Rectangle)
  Adds a rectangle to this rectangle.
contains(int, int)
  Checks whether this rectangle contains the point at the specified location (x, y).
contains(Point)
  Checks whether this rectangle contains the specified point.
equals(Object)
  Checks whether two rectangles are equal.
getBounds()
  Gets the bounding rectangle of this rectangle.
getLocation()
  Returns the location of this rectangle.
getSize()
  Gets the size (width and height) of this rectangle.
grow(int, int)
  Grows the rectangle both horizontally and vertically.
hashCode()
  Returns the hashcode for this rectangle.
inside(int, int)
  Deprecated.
intersection(Rectangle)
  Computes the intersection of this rectangle with the specified rectangle.
intersects(Rectangle)
  Determines whether this rectangle and the specified rectangle intersect.
isEmpty()
  Determines whether this rectangle is empty.
move(int, int)
  Deprecated.
reshape(int, int, int, int)
  Deprecated.
resize(int, int)
  Deprecated.
setBounds(int, int, int, int)
  Sets the bounding rectangle of this rectangle to the specified values for `x`, `y`, `width`, and `height`.
setBounds(Rectangle)
  Sets the bounding rectangle of this rectangle to match the specified rectangle.
setLocation(int, int)
  Moves the rectangle to the specified location.
setLocation(Point)
  Moves the rectangle to the specified location.
setSize(Dimension)
  Sets the size of this rectangle to match the specified dimension.
setSize(int, int)
  Sets the size of this rectangle to the specified width and height.
toString()
  Returns a string representation of this rectangle and its values.
translate(int, int)
  Translates the rectangle the indicated distance, to the right along the x coordinate axis, and downward along the y coordinate axis.
union(Rectangle)
  Computes the union of this rectangle with the specified rectangle.

##

x

     public int x

  The x coordinate of the rectangle.

y

     public int y

  The y coordinate of the rectangle.

width

     public int width

  The width of the rectangle.

height

     public int height

  The height of the rectangle.

##

Rectangle

     public Rectangle()

  Constructs a new rectangle whose top-left corner is at (0, 0) in the coordinate space, and whose width and height are zero.

Rectangle

     public Rectangle(Rectangle r)

  Constructs a new rectangle, initialized to match the values of the specificed rectangle.

  Parameters:
    r - a rectangle from which to copy initial values.

Rectangle

     public Rectangle(int x,
                      int y,
                      int width,
                      int height)

  Constructs a new rectangle whose top-left corner is specified as (`x`, `y`) and whose width and height are specified by the arguments of the same name.

  Parameters:
    x - the x coordinate.
    y - the y coordinate.
    width - the width of the rectangle.
    height - the height of the rectangle.

Rectangle

     public Rectangle(int width,
                      int height)

  Constructs a new rectangle whose top-left corner is at (0, 0) in the coordinate space, and whose width and height are specified by the arguments of the same name.

  Parameters:
    width - the width of the rectangle.
    height - the height of the rectangle.

Rectangle

     public Rectangle(Point p,
                      Dimension d)

  Constructs a new rectangle whose top-left corner is specified by the `point` argument, and whose width and height are specified by the `dimension` argument.

  Parameters:
    p - a point, the top-left corner of the rectangle.
    d - a dimension, representing the width and height.

Rectangle

     public Rectangle(Point p)

  Constructs a new rectangle whose top-left corner is the specified point, and whose width and height are zero.

  Parameters:
    p - the top left corner of the rectangle.

Rectangle

     public Rectangle(Dimension d)

  Constructs a new rectangle whose top left corner is (0, 0) and whose width and height are specified by the `dimension` argument.

  Parameters:
    d - a dimension, specifying width and height.

##

getBounds

     public Rectangle getBounds()

  Gets the bounding rectangle of this rectangle.

  This method is included for completeness, to parallel the `getBounds` method of `Component`.

  Returns:
    a new rectangle, equal to the bounding rectangle for this rectangle.
  See Also:
    getBounds

setBounds

     public void setBounds(Rectangle r)

  Sets the bounding rectangle of this rectangle to match the specified rectangle.

  This method is included for completeness, to parallel the `setBounds` method of `Component`.

  Parameters:
    r - a rectangle.
  See Also:
    setBounds

setBounds

     public void setBounds(int x,
                           int y,
                           int width,
                           int height)

  Sets the bounding rectangle of this rectangle to the specified values for `x`, `y`, `width`, and `height`.

  This method is included for completeness, to parallel the `setBounds` method of `Component`.

  Parameters:
    x - the new x coordinate for the top-left corner of this rectangle.
    y - the new y coordinate for the top-left corner of this rectangle.
    width - the new width for this rectangle.
    height - the new height for this rectangle.
  See Also:
    setBounds

reshape

     public void reshape(int x,
                         int y,
                         int width,
                         int height)

  Note: reshape() is deprecated. As of JDK version 1.1, replaced by `setBounds(int, int, int, int)`.

getLocation

     public Point getLocation()

  Returns the location of this rectangle.

  This method is included for completeness, to parallel the `getLocation` method of `Component`.

  See Also:
    getLocation

setLocation

     public void setLocation(Point p)

  Moves the rectangle to the specified location.

  This method is included for completeness, to parallel the `setLocation` method of `Component`.

  Parameters:
    p - the new location for the point.
  See Also:
    setLocation

setLocation

     public void setLocation(int x,
                             int y)

  Moves the rectangle to the specified location.

  This method is included for completeness, to parallel the `setLocation` method of `Component`.

  Parameters:
    x - the x coordinate of the new location.
    y - the y coordinate of the new location.
  See Also:
    setLocation

move

     public void move(int x,
                      int y)

  Note: move() is deprecated. As of JDK version 1.1, replaced by `setLocation(int, int)`.

translate

     public void translate(int x,
                           int y)

  Translates the rectangle the indicated distance, to the right along the x coordinate axis, and downward along the y coordinate axis.

  Parameters:
    dx - the distance to move the rectangle along the x axis.
    dy - the distance to move the rectangle along the y axis.
  See Also:
    setLocation, setLocation

getSize

     public Dimension getSize()

  Gets the size (width and height) of this rectangle.

  This method is included for completeness, to parallel the `getSize` method of `Component`.

  Returns:
    a dimension, representing the size.
  See Also:
    getSize

setSize

     public void setSize(Dimension d)

  Sets the size of this rectangle to match the specified dimension.

  This method is included for completeness, to parallel the `setSize` method of `Component`.

  Parameters:
    d - the new size for the Dimension object
  See Also:
    setSize

setSize

     public void setSize(int width,
                         int height)

  Sets the size of this rectangle to the specified width and height.

  This method is included for completeness, to parallel the `setSize` method of `Component`.

  Parameters:
    width - the new width for this rectangle object.
    height - the new height for this rectangle object.
  See Also:
    setSize

resize

     public void resize(int width,
                        int height)

  Note: resize() is deprecated. As of JDK version 1.1, replaced by `setSize(int, int)`.

contains

     public boolean contains(Point p)

  Checks whether this rectangle contains the specified point.

  Parameters:
    p - the point (location) to test.
  Returns:
    `true` if the point (x, y) is inside this rectangle; `false` otherwise.

contains

     public boolean contains(int x,
                             int y)

  Checks whether this rectangle contains the point at the specified location (x, y).

  Parameters:
    x - the x coordinate.
    y - the y coordinate.
  Returns:
    `true` if the point (x, y) is inside this rectangle; `false` otherwise.

inside

     public boolean inside(int x,
                           int y)

  Note: inside() is deprecated. As of JDK version 1.1, replaced by `contains(int, int)`.

intersects

     public boolean intersects(Rectangle r)

  Determines whether this rectangle and the specified rectangle intersect. Two rectangles intersect if their intersection is nonempty.

  Parameters:
    r - a rectangle.
  Returns:
    `true` if the specified rectangle and this rectangle insersect; `false` otherwise.

intersection

     public Rectangle intersection(Rectangle r)

  Computes the intersection of this rectangle with the specified rectangle. Returns a new rectangle that represents the intersection of the two rectangles.

  Parameters:
    r - a rectangle.
  Returns:
    the largest rectangle contained in both the specified rectangle and in this rectangle.

union

     public Rectangle union(Rectangle r)

  Computes the union of this rectangle with the specified rectangle. Returns a new rectangle that represents the union of the two rectangles.

  Parameters:
    r - a rectangle.
  Returns:
    the smallest rectangle containing both the specified rectangle and this rectangle.

add

     public void add(int newx,
                     int newy)

  Adds a point, specified by the integer arguments `newx` and `newy`, to this rectangle. The resulting rectangle is the smallest rectangle that contains both the original rectangle and the specified point.

  After adding a point, a call to `contains`with the added point as an argument will not necessarily return `true`. The `contains` method does not return `true` for points on the right or bottom edges of a rectangle. Therefore if the added point falls on the left or bottom edge of the enlarged rectangle, `contains` will return `false` for that point.``

  Parameters:
    newx - the x coordinate of the new point.
    newy - the y coordinate of the new point.

add

     public void add(Point pt)

  Adds the point `pt` to this rectangle. The resulting rectangle is the smallest rectangle that contains both the original rectangle and the specified point.

  After adding a point, a call to `contains`with the added point as an argument will not necessarily return `true`. The `contains` method does not return `true` for points on the right or bottom edges of a rectangle. Therefore if the added point falls on the left or bottom edge of the enlarged rectangle, `contains` will return `false` for that point.``

  Parameters:
    pt - the new point to add to the rectangle.

add

     public void add(Rectangle r)

  Adds a rectangle to this rectangle. The resulting rectangle is the union of the two rectangles.

  Parameters:
    a - rectangle.

grow

     public void grow(int h,
                      int v)

  Grows the rectangle both horizontally and vertically.

  This method modifies the rectangle so that it is `h` units larger on both the left and right side, and `v` units larger at both the top and bottom.

  The new rectangle has (`x - h`, `y - v`) as its top-left corner, a width of `width` `+` `2h`, and a height of `height` `+` `2v`.

  If negative values are supplied for `h` and `v`, the size of the rectangle decreases accordingly. The `grow` method does not check whether the resulting values of `width` and `height` are non-negative.

  Parameters:
    h - the horizontal expansion.
    v - the vertical expansion.

isEmpty

     public boolean isEmpty()

  Determines whether this rectangle is empty. A rectangle is empty if its width or its height is less than or equal to zero.

  Returns:
    `true` if this rectangle is empty; `false` otherwise.

hashCode

     public int hashCode()

  Returns the hashcode for this rectangle.

  Returns:
    the hashcode for this rectangle.
  Overrides:
    hashCode in class Object

equals

     public boolean equals(Object obj)

  Checks whether two rectangles are equal.

  The result is `true` if and only if the argument is not `null` and is a `Rectangle` object that has the same top-left corner, width, and height as this rectangle.

  Parameters:
    obj - the object to compare with.
  Returns:
    `true` if the objects are equal; `false` otherwise.
  Overrides:
    equals in class Object

toString

     public String toString()

  Returns a string representation of this rectangle and its values.

  Returns:
    a string representation of this rectangle.
  Overrides:
    toString in class Object

    All Packages  Class Hierarchy  This Package  Previous  Next  Index

Submit a bug or feature - Version 1.1.8 of Java Platform API Specification
Java is a trademark or registered trademark of Sun Microsystems, Inc. in the US and other countries.
Copyright 1995-1999 Sun Microsystems, Inc. 901 San Antonio Road,
Palo Alto, California, 94303, U.S.A. All Rights Reserved.